﻿using System;

namespace Binäre_Suche
{
    public static class BinarySeek<T> where T : IComparable
    {
        public static int FoundIndex { get; private set; }

        public static bool IsFound { get; private set; }

        public static int SeekSteps { get; private set; }

        private static int mitte;

        public static bool SeekIterative(T[] array, T seekelement)
        {
            // Guard Clauses
            if (array == null) throw new ArgumentNullException("array");
            if (seekelement == null) throw new ArgumentNullException("seekelement");

            FoundIndex = 0;
            IsFound = false;
            SeekSteps = 0;

            int unteregrenze = 0;
            int oberegrenze = array.Length - 1;

            while (unteregrenze <= oberegrenze)
            {
                mitte = unteregrenze + (oberegrenze - unteregrenze) / 2;

                // array[mitte] < seekelement --> -1
                // array[mitte] > seekelement --> 1
                // array[mitte] = seekelement --> 0

                int rc = array[mitte].CompareTo(seekelement);
                if (rc == 1)
                    oberegrenze = mitte - 1;
                else if (rc == -1)
                    unteregrenze = mitte + 1;
                else
                {
                    FoundIndex = mitte;
                    IsFound = true;
                    break;
                }
                SeekSteps++;
            }
            return IsFound;
        }

        public static bool SeekRecursive(T[] array, T seekelement)
        {
            // Guard Clauses
            if (array == null) throw new ArgumentNullException("array");
            if (seekelement == null) throw new ArgumentNullException("seekelement");

            FoundIndex = 0;
            IsFound = false;

            return BinarySearch(array, 0, array.Length - 1, seekelement);
        }

        private static bool BinarySearch(T[] array, int untereGrenze, int obereGrenze, T seekelement)
        {
            if (untereGrenze > obereGrenze)
                return false;
            mitte = untereGrenze + (obereGrenze - untereGrenze) / 2;

            // array[mitte] < seekelement --> -1
            // array[mitte] > seekelement --> 1
            // array[mitte] = seekelement --> 0

            int rc = array[mitte].CompareTo(seekelement);
            if (rc == 1)
            {
                SeekSteps++;
                return BinarySearch(array, untereGrenze, mitte - 1, seekelement);
            }
                
            if (rc == -1)
            {
                SeekSteps++;
                return BinarySearch(array, mitte + 1, obereGrenze, seekelement);
            }

            FoundIndex = mitte;
            IsFound = true;
            return IsFound;
        }

    }
}
