﻿using System;
using System.Diagnostics;

namespace Binäre_Suche
{
    class Program
    {
        static void Main(string[] args)
        {
            // Zufallszahlen generieren
            Random rnd = new Random();

            int[] intarray = new int[10000000];

            // Array mit Zahlen befüllen
            Console.Write("Array befüllen...");
            for (int i = 0; i < intarray.Length; i++)
            {
                // Zufallszahlen zwischen 1 und 1.000.000 verwenden
                intarray[i] = rnd.Next(1,1000001);
            }
            Console.WriteLine("fertig!");

            // Sortieren des Arrays
            Console.Write("Array sortieren...");
            Array.Sort(intarray);
            Console.WriteLine("fertig!");

            Console.WriteLine("Binäres Suchen in einem Array mit {0:N0} int-Werten", intarray.Length);
            Console.Write("Zu suchende Zahl > ");
            int zusuchendezahl = Convert.ToInt32(Console.ReadLine());
            Console.WriteLine("Suche nach der Zahl {0}", zusuchendezahl);

            Stopwatch watch = new Stopwatch();
            watch.Start();
            bool gefunden = BinarySeek<int>.SeekIterative(intarray, zusuchendezahl);
            watch.Stop();

            if (gefunden)
            { 
                Console.WriteLine("Wert an Stelle von Index {1}: {0}", intarray[BinarySeek<int>.FoundIndex], BinarySeek<int>.FoundIndex);
                Console.WriteLine("Anzahl Suchschritte: {0}", BinarySeek<int>.SeekSteps);
            }
            else
                Console.WriteLine("Wert nicht gefunden!");

            Console.WriteLine("Zeitdauer: {0}", watch.Elapsed.ToString());
            Console.WriteLine("===================================================");


            
            Person[] personarray = new Person[5];
            personarray[0] = new Person("Uwe", "Homm");
            personarray[1] = new Person("Friedhelm", "Ernst");
            personarray[2] = new Person("Christoph", "Krekel");
            personarray[3] = new Person("Patricia", "Binder");
            personarray[4] = new Person("Sylvia", "Mazurek");

            // Sortieren des Arrays (basiert auf der CompareTo()-Methode)
            Array.Sort(personarray);

            Console.WriteLine("Binäres Suchen in einem Array mit {0:N0} Person-Objekte", personarray.Length);
            Console.WriteLine("Zu suchende Person");


            //Alternativ
            //Person zusuchendeperson = new Person("Patricia", "Binder");
            string vname, nname;
            Console.Write("Vorname > "); vname = Console.ReadLine();
            Console.Write("Nachname > "); nname = Console.ReadLine();
            Person zusuchendeperson = new Person(vname, nname);

            Console.WriteLine("Suche nach der Person {0}", zusuchendeperson.VollerName);

            watch.Start();
            gefunden = BinarySeek<Person>.SeekRecursive(personarray, zusuchendeperson);
            watch.Stop();

            if (gefunden)
            {
                Console.WriteLine("Wert an Stelle von Index {1}: {0}", personarray[BinarySeek<Person>.FoundIndex].VollerName,
                                                                       BinarySeek<Person>.FoundIndex);
                Console.WriteLine("Anzahl Suchschritte: {0}", BinarySeek<Person>.SeekSteps);
            }
            else
                Console.WriteLine("Wert nicht gefunden!");

            Console.WriteLine("Zeitdauer: {0}", watch.Elapsed.ToString());
            Console.WriteLine("===================================================");
            
        }
    }
}
