﻿using System;

namespace Lineare_Suche
{
    // Der Datentyp T muss das das Interface
    // IComparable implementieren
    public static class LinearSeek<T> where T:IComparable
    {
        public static int FoundIndex { get; private set; }

        public static bool IsFound { get; private set; }

        public static bool Seek(T[] array, T seekelement)
        {
            // Guard Clauses
            if (array == null) throw new ArgumentNullException("array");
            if (seekelement == null) throw new ArgumentNullException("seekelement");

            FoundIndex = 0;
            IsFound = false;

            foreach (T item in array)
            {
                if (item.CompareTo(seekelement) == 0)
                {
                    IsFound = true;
                    break;
                }
                FoundIndex++;
            }
            return IsFound;
        }

    }
}
