﻿using System;
using System.Collections.Generic;
using System.Diagnostics;

namespace Lineare_Suche
{
    class Program
    {
        static void Main(string[] args)
        {
            // Zufallszahlen generieren
            Random rnd = new Random();

            int[] intarray = new int[10000000];

            // Array mit Zahlen befüllen
            for (int i = 0; i < intarray.Length; i++)
            {
                // Zufallszahlen zwischen 1 und 10000 verwenden
                intarray[i] = rnd.Next(1,10001);
            }

            Console.WriteLine("Lineares Suchen in einem Array mit {0:N0} int-Werten",intarray.Length);
            Console.Write("Zu suchende Zahl > ");
            int zusuchendezahl = Convert.ToInt32(Console.ReadLine());
            Console.WriteLine("Suche nach der Zahl {0}", zusuchendezahl);

            Stopwatch watch = new Stopwatch();
            watch.Start();
            bool gefunden = LinearSeek<int>.Seek(intarray, zusuchendezahl);
            watch.Stop();

            if (gefunden)
                Console.WriteLine("Wert an Stelle von Index {1}: {0}", intarray[LinearSeek<int>.FoundIndex], LinearSeek<int>.FoundIndex);
            else
                Console.WriteLine("Wert nicht gefunden!");

            Console.WriteLine("Zeitdauer: {0}", watch.Elapsed.ToString());
            Console.WriteLine("===================================================");

            Person[] personarray = new Person[5];
            personarray[0] = new Person("Uwe", "Homm");
            personarray[1] = new Person("Friedhelm", "Ernst");
            personarray[2] = new Person("Christoph", "Krekel");
            personarray[3] = new Person("Patricia", "Binder");
            personarray[4] = new Person("Sylvia", "Mazurek");

            Console.WriteLine("Lineares Suchen in einem Array mit {0:N0} Person-Objekte", personarray.Length);
            Console.WriteLine("Zu suchende Person");

            //Alternativ
            //Person zusuchendeperson = new Person("Patricia", "Binder");
            string vname, nname;
            Console.Write("Vorname > "); vname = Console.ReadLine();
            Console.Write("Nachname > "); nname = Console.ReadLine();
            Person zusuchendeperson = new Person(vname, nname);

            Console.WriteLine("Suche nach der Person {0}", zusuchendeperson.VollerName);

            watch.Start();
            gefunden = LinearSeek<Person>.Seek(personarray, zusuchendeperson);
            watch.Stop();

            if (gefunden)
                Console.WriteLine("Wert an Stelle von Index {1}: {0}", personarray[LinearSeek<Person>.FoundIndex].VollerName,
                                                                       LinearSeek<Person>.FoundIndex);
            else
                Console.WriteLine("Wert nicht gefunden!");

            Console.WriteLine("Zeitdauer: {0}", watch.Elapsed.ToString());
            Console.WriteLine("===================================================");

            Circle[] circlearray = new Circle[4];
            circlearray[0] = new Circle(10.5);
            circlearray[1] = new Circle(3.14);
            circlearray[2] = new Circle(2.71828);
            circlearray[3] = new Circle(123.45);

            Console.WriteLine("Zu suchender Kreis");
            Console.Write("Radius = "); double radius = Convert.ToDouble(Console.ReadLine());
            Circle suchcircle = new Circle(radius);
            gefunden = LinearSeek<Circle>.Seek(circlearray, suchcircle);

            if (gefunden)
                Console.WriteLine("Wert an Stelle von Index {1}: {0}", circlearray[LinearSeek<Circle>.FoundIndex].Radius,
                                                                       LinearSeek<Circle>.FoundIndex);
            else
                Console.WriteLine("Wert nicht gefunden!");

        }
    }
}
