﻿using System;

public class Person:IComparable
{
    public string Vorname { get; private set; }
    public string Nachname { get; private set; }

    public string VollerName
    {
        get { return Vorname + " " + Nachname; }
    }
    public Person(string vorname, string nachname)
	{
        Vorname = vorname;
        Nachname = nachname;
	}

    // Für IComparable muss die Methode
    // CompareTo() implementiert werden
    public int CompareTo(object obj)
    {
        Person p = (Person)obj;
        // Besonderheit beim Vergleich von Strings
        // Der Datentyp string hat bereits CompareTo() eingebaut
        
        // Berücksichtigt Groß- und Kleinschreibung
        //return this.VollerName.CompareTo(p.VollerName);
        
        // Unabhängig von Groß- und Kleinschreibung
        return this.VollerName.ToUpper().CompareTo(p.VollerName.ToUpper());
    }
}
